//InputInventory.vue

<template>
  <div>
    <p></p>
    SessionID: {{ this.sessionID }}
    <button class="inventory-btns" @click="editID" style="margin-left: 1rem">edit</button>
    <form id="newSessionID">
      <input id="newID" placeholder="Enter new SessionID">
      <button class="inventory-btns" @click.prevent="confirmID" type="button">confirm</button>
    </form>
  </div>
  <div style="padding-top: 5px">
    <input v-model="newItemUPC" placeholder="upc"><input v-model="newItemName" placeholder="name"><input v-model="newItemQuantity" placeholder="quantity">
    <button class="inventory-btns" @click="addItem">Add Item</button>
    <p></p>
    <div v-show="addItemStatus === 'errored'">Could not add item.</div>
    <div v-show="addItemStatus === 'error:upc'">UPC code error</div>
    <div v-show="addItemStatus === 'error:quantity'">Quantity must be a number</div>
    <div v-show="addItemStatus === 'sending'">Adding item. Please wait...</div>
    <p></p>
    <table>
        <thead>
          <tr>
            <th style="width: 10rem;">
              UPC
            </th>
            <th style="width: 20rem;">
              Name
            </th>
            <th style="width: 5rem;">
              Quantity
            </th>
          </tr>
        </thead>
        <tbody>
          <tr v-for="item in items" :key="item.upc">
            <td :class="'inventory-no-' + (items.indexOf(item) + 1)" v-if="item">{{item.upc}}</td>
            <td :class="'inventory-no-' + (items.indexOf(item) + 1)" v-if="item">{{item.name}}</td>
            <td :class="'inventory-no-' + (items.indexOf(item) + 1)" v-if="item">{{item.quantity}}</td>
            <button class="inventory-btns" :id="'inventoryEditBtn-' + (items.indexOf(item) + 1)" style="display: block" @click="editInventoryEntry(items.indexOf(item) + 1)">Edit</button>
            <button class="inventory-btns" :id="'inventoryUpdateBtn-' + (items.indexOf(item) + 1)" style="display: none" @click="updateInventoryEntry(items.indexOf(item) + 1)">Update</button>
            <button class="inventory-btns" :id="'inventoryCancelBtn-' + (items.indexOf(item) + 1)" style="display: none" @click="cancelInventoryChange(items.indexOf(item) + 1)">Cancel</button>
          </tr>
        </tbody>
      </table>
  </div>
  <div style="margin-top: 50px">
    <button class="inventory-btns" @click="submit">Submit</button>
    <p class="submitStatus">{{ isSubmitSuccessful }}</p>
  </div>
  
</template>

<script>
import axios from 'axios';
import router from '../router';
import { BACKEND_BASE_URL } from '../env.js';

export default {
  name: 'InputInventory',
  data(){
    return {
      items: [],
      newItemUPC: '',
      newItemName: '',
      newItemQuantity: '',
      addItemStatus: 'idle', // sending, errored
      sessionID: '',
      isSubmitSuccessful: ''
    }
  }, 
  created: function() {
    const today = new Date();
    let mm, dd, yyyy;
    let m = today.getMonth() + 1;
    if (m < 10) {mm = '0' + m}
    else {mm = '' + m}
    dd = '' + today.getDate();
    if (parseInt(dd) < 10) {dd = '0' + dd}
    yyyy = today.getFullYear();
    const id = mm + '-' + dd + '-' + yyyy;
    this.sessionID = id;
  },
  methods: {
    addItem() {
      if (!(/\d{12}/.test(this.newItemUPC))) {
        this.addItemStatus='error:upc'
        return
      }
      if (!(/\d+/.test(this.newItemQuantity))) {
        this.addItemStatus='error:quantity'
        return
      }
      let newItem = { upc: this.newItemUPC, name: this.newItemName, quantity: parseInt(this.newItemQuantity), sessionID: this.sessionID };
      this.newItemUPC = '';
      this.newItemName = '';
      this.newItemQuantity = '';
      this.items.push(newItem)
    },
    async submit() {
      try {
        const postRes = await axios.post(BACKEND_BASE_URL + "/entries", {entries:this.items,sessionID:this.sessionID});
        console.log(postRes);
        this.isSubmitSuccessful = "Successfully submitted!";
      } catch (error) {
        console.error(error);
        this.addItemStatus = 'errored';
      }
      
      // go back to home page
      setTimeout(() => {
        router.push({ name:'Home' });
        }, 1500); 

    },
    editID() {
      let form = document.getElementById("newSessionID");
      form.style.display = "block";
    },
    confirmID() {
      let form = document.getElementById("newSessionID");
      let newID = document.getElementById("newID").value;
      this.sessionID = newID;
      form.style.display = "none";
    },
    editInventoryEntry(row_no) {
      const editBtnId = "inventoryEditBtn-" + row_no;
      const updateBtnId = "inventoryUpdateBtn-" + row_no;
      const cancelBtnId = "inventoryCancelBtn-" + row_no;
      document.getElementById(editBtnId).style.display = "none";
      document.getElementById(updateBtnId).style.display = "inline-block";
      document.getElementById(cancelBtnId).style.display = "inline-block";
      const class_name = "inventory-no-" + row_no;
      var tempItemsList = document.getElementsByClassName(class_name);
      var itemsList = Array.from(tempItemsList);
      itemsList.forEach( item => item.setAttribute("contenteditable", "true"));
      itemsList[itemsList.length - 1].focus();
    },
    cancelInventoryChange(row_no) {
      const editBtnId = "inventoryEditBtn-" + row_no;
      const updateBtnId = "inventoryUpdateBtn-" + row_no;
      const cancelBtnId = "inventoryCancelBtn-" + row_no;
      document.getElementById(editBtnId).style.display = "block";
      document.getElementById(updateBtnId).style.display = "none";
      document.getElementById(cancelBtnId).style.display = "none";
      const class_name = "inventory-no-" + row_no;
      var tempItemsList = document.getElementsByClassName(class_name);
      var itemsList = Array.from(tempItemsList);
      itemsList.forEach( item => item.setAttribute("contenteditable", "false"));
    },
    updateInventoryEntry(row_no) {
      const editBtnId = "inventoryEditBtn-" + row_no;
      const updateBtnId = "inventoryUpdateBtn-" + row_no;
      const cancelBtnId = "inventoryCancelBtn-" + row_no;
      document.getElementById(editBtnId).style.display = "block";
      document.getElementById(updateBtnId).style.display = "none";
      document.getElementById(cancelBtnId).style.display = "none";

      const class_name = "inventory-no-" + row_no;
      var tempItemsList = document.getElementsByClassName(class_name);
      var itemsList = Array.from(tempItemsList);
      itemsList.forEach( item => item.setAttribute("contenteditable", "false"));
      
      let newItemUPC = itemsList[0].innerHTML;
      let newItemName = itemsList[1].innerHTML;
      let newItemQuantity = parseInt(itemsList[2].innerHTML);
      let sessionID = this.sessionID;
      let newItem = { upc: newItemUPC, name: newItemName, quantity: newItemQuantity, sessionID: sessionID };

      this.items[row_no - 1] = newItem;

    }
  }
}
</script>

<style>
  #newSessionID {
    display: none
  }

  table {
    margin-left: auto; 
    margin-right: auto
  }

  th {
    text-align: left
  }

  td {
    text-align: left
  }

  .inventory-btns {
    font-size: .8rem;
    font-weight: bold;
    padding-top: .1rem;
    padding-bottom: .1rem;
  }

  .inventory-btns:hover {
    color: blue
  }
  
  .submitStatus {
    font-weight: bold;
    margin-top: .5rem;
    font-size: .9rem;
    color: #519b34;
  }

</style>